#ifndef _MISCFUNC_HPP
#define _MISCFUNC_HPP

/* Debug routines */

void startdebug (int fn = -1);
void restartdebug (int fn = -1);
void enddebug (int fn = -1);
void debugf (int fn, char *format, ...);
void debug0 (char *format, ...);

/* Timer stuff */

extern volatile long int ticks, tmsec, oldticks;

void inittimer (void);
void tdelay (int msec);
void uninittimer (void);

/* Mouse stuff */

extern int mousex, mousey, mouseres;
extern boolean lbutton, rbutton;
void initmouse ();
void checkmouse (); // updates mousex, mousey, lbutton, and rbutton.

/* Keyboard & joystick stuff */

extern char keyname [128] [6];
extern volatile boolean keydown [128];

void initkeyboard (void);
void uninitkeyboard (void);

extern word joyminx, joymaxx, joyminy, joymaxy, joythresh;
extern word joymidx, joymidy, joyposx, joyposy;

void resetjoysettings ();
void checkjoystick ();

struct snesjoypad { // The keyboard scancodes for the joypad
	byte up, down, left, right;
	byte x, y, a, b, l, r;
	byte select, start;
};

#define KEYUP 72
#define KEYDOWN 80
#define KEYLEFT 75
#define KEYRIGHT 77
#define KEYENTER 28
#define KEYTAB 15
#define KEYESC 1
#define KEYLSHIFT 42
#define KEYRSHIFT 54
#define KEYCONTROL 29
#define KEYALT 56
#define KEYSPACE 57

extern struct snesjoypad joykey [6];

#endif
